"use strict";

exports.__esModule = true;

var GetSpotPos =
/** @class */
function () {
  function GetSpotPos(setPos, configuration, radiuss) {
    var _this = this;

    this.dotCoordinates = []; //备份生成的位置

    this.getPos = function (configuration) {
      configuration.map(function (size, k) {
        var temp = {
          x: 0,
          y: 0,
          size: 25
        };

        if (k == 0) {
          //第一个
          var yinzi = [1, -1];
          var yinziX = yinzi[Math.round(Math.random())];
          var yinziY = yinzi[Math.round(Math.random())]; // 靠近圆心，根据象限随机位置(减去小圆半径是为了获得坐标值，保证小圆在大圆圆心附近)

          var x = _this.radius + yinziX * Math.floor(Math.random() * size) - size;
          var y = _this.radius + yinziY * Math.floor(Math.random() * size) - size;
          temp.x = x;
          temp.y = y;
          temp.size = size;
        } else {
          // let prePos = this.dotCoordinates[this.dotCoordinates.length-1];
          var x = Math.floor(Math.random() * (_this.radius - size - 20) * 2);
          var y = Math.floor(Math.random() * (_this.radius - size - 20) * 2);

          while (_this.crash(x, y, size)) {
            x = Math.floor(Math.random() * (_this.radius - size - 20) * 2);
            y = Math.floor(Math.random() * (_this.radius - size - 20) * 2);
          }

          temp.x = x;
          temp.y = y;
          temp.size = size;
        }

        _this.dotCoordinates.push(temp);

        _this.setPos(temp);
      });
    };

    this.setPos = setPos;
    this.radius = radiuss > 150 ? radiuss : 150;
    this.getPos(configuration);
  }

  GetSpotPos.prototype.crash = function (x, y, size) {
    var _this = this;

    var result = false;
    var distance = 15;
    var centerX = x + size;
    var centerY = y + size;
    var distanceToBigCenter = Math.sqrt(Math.pow(centerX - this.radius, 2) + Math.pow(centerY - this.radius, 2));
    this.dotCoordinates.map(function (dot) {
      if (y < 30 || x < 20 || x > (_this.radius - size) * 2 || y > (_this.radius - size) * 2) {
        //保证不靠边，tip能显示
        result = result || true;
      }

      if (distanceToBigCenter > _this.radius - 2 * size) {
        //检测到圆心的距离,保证是圆形区域
        result = result || true;
      }

      if (dot.x == x) {
        if (dot.y > y) {
          result = result || dot.y - y < 2 * size + distance;
        } else {
          result = result || y - dot.y < 2 * dot.size + distance;
        }
      } else if (dot.y == y) {
        if (dot.x > x) {
          result = result || dot.x - x < 2 * size + distance;
        } else {
          result = result || x - dot.x < 2 * dot.size + distance;
        }
      } else {
        //检测两个小圆圆心的距离
        var tarDistance = dot.size + size + distance;
        var dotCenterX = dot.x + dot.size;
        var dotCenterY = dot.y + dot.size;
        var tempDistance = Math.sqrt(Math.pow(dotCenterY - centerY, 2) + Math.pow(dotCenterX - centerX, 2));
        result = result || tempDistance < tarDistance;
      }
    });
    return result;
  };

  return GetSpotPos;
}();

exports["default"] = GetSpotPos;