"use strict";

exports.__esModule = true;

var helper_1 = require("../helper");

function getCloudApiUrl(url) {
  var env = helper_1.getBSGlobal('env');
  var staticMap = ['https://cloud.italent-inc.cn', 'https://cloud.italent.link', 'https://cloud.italent.cn'];

  switch (env) {
    case 'Development':
      //开发develop
      return staticMap[0] + url;

    case 'develop':
      return staticMap[0] + url;

    case 'Production':
      //线上
      return staticMap[2] + url;

    case 'Testing':
      return staticMap[1] + url;

    default:
      return staticMap[2] + url;
  }
}

exports.getCloudApiUrl = getCloudApiUrl;

function getCloudApiUrl2(url) {
  var env = helper_1.getBSGlobal('env');
  var staticMap = ['//cloud.italent-inc.cn', '//cloud.italent.link', '//cloud.italent.cn'];

  switch (env) {
    case 'Development':
      //开发develop
      return staticMap[0] + url;

    case 'develop':
      return staticMap[0] + url;

    case 'Production':
      //线上
      return staticMap[2] + url;

    case 'Testing':
      return staticMap[1] + url;

    default:
      return staticMap[2] + url;
  }
}

exports.getCloudApiUrl2 = getCloudApiUrl2;

function getCloudData(url) {}

exports.getCloudData = getCloudData;